void data_send() {

  while (Serial.available()) Serial.read();
  Serial.print("connecting to ");
  Serial.println(host);

  // Use WiFiClient class to create TCP connections
  WiFiClient client;
  const int httpPort = 80;
  if (!client.connect(host, httpPort)) {
    Serial.println("connection failed");
    return;
  }

  // We now create a URI for the request
  String url = "/get?cid=";
  url += streamId;
  url += "&key=";
  url += privateKey;

  if ( dataTrade == true ) // Если хотя бы один пакект в последнем обмене был принят без ошибок - считаем что связь есть
  {
    url += "&p1=";
    url += pv_V;
    url += "&p2=";
    url += pv_I;
    url += "&p3=";
    url += batt_V;
    url += "&p4=";
    url += batt_I;
    url += "&p5=";
    url += load_U;
    url += "&p6=";
    url += load_I;
    url += "&p7=";
    url += batt_T;
    url += "&p8=";
    url += batt_SOC;
    url += "&p9=";
    url += EnergyToday;
    url += "&p10=";
    url += EnergyTotal;
    url += "&p11=";
    url += histogram ();
    url += "&p16=";
    url += batt_Status;
    url += "&p17=";
    url += ch_Status;

    url += "&p18=";
    url += "controller_data_OK";
  }
  else {
    url += "&p18=";
    url += "controller_no_data";
  }

  Serial.print("Requesting URL: ");
  Serial.println(url);

  // This will send the request to the server
  client.print(String("GET ") + url + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" +
               "Connection: close\r\n\r\n");
  unsigned long timeout = millis();
  while (client.available() == 0) {
    if (millis() - timeout > 5000) {
      Serial.println(">>> Client Timeout !");
      client.stop();
      return;
    }
  }

  // Read all the lines of the reply from server and print them to Serial
  while (client.available()) {
    String line = client.readStringUntil('\r');
    if (line == "\n1<br>") {
      Serial.println("Данные успешно сохранены в облаке");
      deltaEnergy = 0 ; // Обнуляем накопленную энергию
      break;
    }
    if (line.length() < 16 ) {
      Serial.print(line);
    }
    yield();
  }

  Serial.println();
  Serial.println("closing connection");
  Serial.println();
}
